/**************************************************************************

	sample

	main.c

	Copyright (C) 1996-2002 by Tomoaki Nakashima. All rights reserved.
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/

/**************************************************************************
	Include Files
**************************************************************************/

#include <windows.h>
#include <tchar.h>

#include "script/script.h"
#include "script/script_memory.h"
#include "script/script_string.h"
#include "script/script_utility.h"

#include "resource.h"


/**************************************************************************
	Define
**************************************************************************/

/**************************************************************************
	Global Variables
**************************************************************************/

/**************************************************************************
	Local Function Prototypes
**************************************************************************/


/******************************************************************************

	DialogProc

	_CAOvV[W

******************************************************************************/

static BOOL CALLBACK DialogProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static SCRIPTINFO *ScriptInfo;

	switch(uMsg)
	{
	case WM_INITDIALOG:
		//
		InitializeScript();
		ScriptInfo = mem_alloc(sizeof(SCRIPTINFO));
		if(ScriptInfo == NULL){
			EndDialog(hDlg, FALSE);
			break;
		}
		InitializeScriptInfo(ScriptInfo, FALSE);
		//XNvg̓ǂݍ
		ReadScriptFile(ScriptInfo, "", "sample.ns");
		//O[ö̎s
		ExecGlobalArea(ScriptInfo);
		break;

	case WM_CLOSE:
		//XNvg̒~
		TerminateScript();
		//XNvg̉
		FreeScriptInfo(ScriptInfo);
		//I
		EndScript();
		EndDialog(hDlg, FALSE);
		break;

	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDC_BUTTON_TIME:
			{
				EXECINFO ei;
				VALUEINFO *vi, *ret;

				//̍쐬
				vi = StringToVariable(NULL, "Time");
				//s̏
				ZeroMemory(&ei, sizeof(EXECINFO));
				ei.sci = ScriptInfo->next;
				ei.sci->param1 = (long)hDlg;
				//֐Ăяo
				ret = ExecFunction(&ei, NULL, "show_datetime", vi, FALSE);
				if(ret == NULL || (int)ret == -1){
					//G[
				}else{
					//߂l̉
					FreeValue(ret);
				}
				//̉
				FreeValue(vi);
			}
			break;

		case IDCANCEL:
			SendMessage(hDlg, WM_CLOSE, 0, 0);
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}


/******************************************************************************

	WinMain

	C

******************************************************************************/

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	DialogBox(hInstance, MAKEINTRESOURCE(IDD_DIALOG), NULL, (DLGPROC)DialogProc);
	return 0;
}
/* End of source */
