/**************************************************************************

	ns

	func_time.c

	Copyright (C) 1996-2002 by Tomoaki Nakashima. All rights reserved.
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/

/**************************************************************************
	Include Files
**************************************************************************/

#include <windows.h>
#include <tchar.h>

#include "script.h"
#include "script_memory.h"
#include "script_string.h"
#include "script_utility.h"


/**************************************************************************
	Define
**************************************************************************/

/**************************************************************************
	Global Variables
**************************************************************************/

/**************************************************************************
	Local Function Prototypes
**************************************************************************/


/******************************************************************************

	_sfunc_getsystemtime

	VXe̎擾

******************************************************************************/

int SFUNC _sfunc_getsystemtime(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	SYSTEMTIME st;

	GetSystemTime(&st);
	SystemtimeToVariable(&st, ret);
	return 0;
}


/******************************************************************************

	_sfunc_setsystemtime

	VXe̐ݒ

******************************************************************************/

int SFUNC _sfunc_setsystemtime(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	SYSTEMTIME st;

	if(param == NULL){
		return -2;
	}
	VariableToSystemtime(&st, param);
	if(SetSystemTime(&st) == FALSE){
		ret->v->u.iValue = -1;
	}else{
		ret->v->u.iValue = 0;
	}
	ret->v->Type = TYPE_INTEGER;
	return 0;
}


/******************************************************************************

	_sfunc_getlocaltime

	[J̎擾

******************************************************************************/

int SFUNC _sfunc_getlocaltime(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	SYSTEMTIME st;

	GetLocalTime(&st);
	SystemtimeToVariable(&st, ret);
	return 0;
}


/******************************************************************************

	_sfunc_setlocaltime

	[J̐ݒ

******************************************************************************/

int SFUNC _sfunc_setlocaltime(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	SYSTEMTIME st;

	if(param == NULL){
		return -2;
	}
	VariableToSystemtime(&st, param);
	if(SetLocalTime(&st) == FALSE){
		ret->v->u.iValue = -1;
	}else{
		ret->v->u.iValue = 0;
	}
	ret->v->Type = TYPE_INTEGER;
	return 0;
}


/******************************************************************************

	_sfunc_difftime

	̔r

******************************************************************************/

int SFUNC _sfunc_difftime(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	SYSTEMTIME st1, st2;
	FILETIME ft1, ft2;
	__int64 t1, t2;

	if(param == NULL){
		return -2;
	}
	VariableToSystemtime(&st1, param);
	SystemTimeToFileTime(&st1, &ft1);
	if((param = param->next) == NULL){
		return -2;
	}
	VariableToSystemtime(&st2, param);
	SystemTimeToFileTime(&st2, &ft2);

	t1 = (unsigned __int64)ft1.dwLowDateTime + (((unsigned __int64)ft1.dwHighDateTime) << 32);
	t2 = (unsigned __int64)ft2.dwLowDateTime + (((unsigned __int64)ft2.dwHighDateTime) << 32);
	ret->v->u.iValue = (long)((t1 - t2) / 10000000);
	ret->v->Type = TYPE_INTEGER;
	return 0;
}
//OLD
int SFUNC _sfunc_comparetime(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	return _sfunc_difftime(ei, param, ret, ErrStr);
}


/******************************************************************************

	_sfunc_getdatestring

	t̎擾

******************************************************************************/

int SFUNC _sfunc_getdatestring(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	SYSTEMTIME st, *s = NULL;
	TCHAR *str;
	TCHAR buf[BUF_SIZE];

	if(param == NULL){
		return -2;
	}

	str = VariableToTString(param);
	if(*str == TEXT('\0')){
		mem_free(&str);
		str = NULL;
	}
	if((param = param->next) != NULL){
		VariableToSystemtime(&st, param);
		s = &st;
	}
	*buf = TEXT('\0');
	GetDateFormat(GetLocale(), 0, s, str, buf, BUF_SIZE - 1);

#ifdef UNICODE
	ret->v->u.Value = tchar2char(buf);
#else
	ret->v->u.Value = alloc_copy(buf);
#endif
	ret->v->Type = TYPE_STRING;
	mem_free(&str);
	return 0;
}
//OLD
int SFUNC _sfunc_getdate(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	return _sfunc_getdatestring(ei, param, ret, ErrStr);
}


/******************************************************************************

	_sfunc_gettimestring

	ԕ̎擾

******************************************************************************/

int SFUNC _sfunc_gettimestring(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	SYSTEMTIME st, *s = NULL;
	TCHAR *str;
	TCHAR buf[BUF_SIZE];

	if(param == NULL){
		return -2;
	}

	str = VariableToTString(param);
	if(*str == TEXT('\0')){
		mem_free(&str);
		str = NULL;
	}
	if((param = param->next) != NULL){
		VariableToSystemtime(&st, param);
		s = &st;
	}
	*buf = TEXT('\0');
	GetTimeFormat(GetLocale(), 0, s, str, buf, BUF_SIZE - 1);

#ifdef UNICODE
	ret->v->u.Value = tchar2char(buf);
#else
	ret->v->u.Value = alloc_copy(buf);
#endif
	ret->v->Type = TYPE_STRING;
	mem_free(&str);
	return 0;
}
//OLD
int SFUNC _sfunc_gettime(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	return _sfunc_gettimestring(ei, param, ret, ErrStr);
}
/* End of source */
