/**************************************************************************

	ns

	functbl.c

	Copyright (C) 1996-2002 by Tomoaki Nakashima. All rights reserved.
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/

/**************************************************************************
	Include Files
**************************************************************************/

#include <windows.h>
#include <tchar.h>

#include "script.h"
#include "script_string.h"


/**************************************************************************
	Function Prototypes
**************************************************************************/

//func_error.c
int SFUNC _sfunc_error(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);

//func_time.c
int SFUNC _sfunc_getsystemtime(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_setsystemtime(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_getlocaltime(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_setlocaltime(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_comparetime(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_difftime(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_getdatestring(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_getdate(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_gettimestring(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);
int SFUNC _sfunc_gettime(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);

//func_msg.c
int SFUNC _sfunc_messagebox(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr);


/**************************************************************************
	Global Variables
**************************************************************************/

typedef struct _FUNCTBL {
	char *name;
	int name_hash;
	LIBFUNC func;
} FUNCTBL;

FUNCTBL ft[] = {
	"_sfunc_error", 0, _sfunc_error,

	"_sfunc_getsystemtime", 0, _sfunc_getsystemtime,
	"_sfunc_setsystemtime", 0, _sfunc_setsystemtime,
	"_sfunc_getlocaltime", 0, _sfunc_getlocaltime,
	"_sfunc_setlocaltime", 0, _sfunc_setlocaltime,
	"_sfunc_comparetime", 0, _sfunc_comparetime,
	"_sfunc_difftime", 0, _sfunc_difftime,
	"_sfunc_getdatestring", 0, _sfunc_getdatestring,
	"_sfunc_getdate", 0, _sfunc_getdate,
	"_sfunc_gettimestring", 0, _sfunc_gettimestring,
	"_sfunc_gettime", 0, _sfunc_gettime,

	"_sfunc_messagebox", 0, _sfunc_messagebox,
};


/******************************************************************************

	InitFuncAddress

	֐e[ȕ

******************************************************************************/

void InitFuncAddress()
{
	int i;

	for(i = 0; i < sizeof(ft) / sizeof(FUNCTBL); i++){
		(ft + i)->name_hash = str2hash((ft + i)->name);
	}
}


/******************************************************************************

	GetFuncAddress

	֐AhX擾

******************************************************************************/

LIBFUNC GetFuncAddress(char *FuncName)
{
	int name_hash;
	int i;

	name_hash = str2hash(FuncName);
	for(i = 0; i < sizeof(ft) / sizeof(FUNCTBL); i++){
		if((ft + i)->name_hash == name_hash && tstrcmp((ft + i)->name, FuncName) == 0){
			return (ft + i)->func;
		}
	}
	return NULL;
}
/* End of source */
